
-- Smoke Grenades
function make_grenade_load(weaponname,username_,modelname,color_,displayname)
	local OH58D_Smoke_Grenade =
	{
		category		= CAT_BOMBS,
		name			= weaponname,
		user_name	 	= _(username_),
		wsTypeOfWeapon  = {wsType_Weapon,wsType_Bomb,wsType_Bomb_A,WSTYPE_PLACEHOLDER},
		scheme = "bomb-smoke",
		model = modelname,
		type    = 0,
		mass    = 0.5,
		hMin    = 1000.0,
		hMax    = 12000.0,
		Cx      = 0.00124,
		VyHold  = -100.0,
		Ag      = -1.23,
		
		fm = 
		{
			mass        = 0.5,  -- empty weight with warhead, wo fuel, kg
			caliber     = 0.1,  -- Caliber, meters 
			cx_coeff    = {1.000000, 0.820000, 0.650000, 0.142000, 2.110000}, -- Cx
			L           = 0.2, -- Length, meters 
			I           = 0.0016, -- kgm2 - moment of inertia  I = 1/12 ML2
			Ma          = 0.42,  -- dependence moment coefficient of  by  AoA angular acceleration  T / I
			Mw          = 0.1, --  rad/s  - 57.3°/s - dependence moment coefficient by angular velocity (|V|*sin(θ))/|r| -  Mw  =  Ma * t
			shapeName = "",
			wind_sigma  = 5, -- dispersion coefficient
			wind_time       = 1000.000000,
			--cx_factor   	= 100,
		},
			
		shape_table_data = 
		{
			{
				file  	 = modelname;
				life  	 = 1;
				fire  	 = { 0, 1};
				username = "Smoke Grenade";
				index = WSTYPE_PLACEHOLDER;
			},
		},
		
		warhead = 
		{
			mass 					= 0.0; 
			expl_mass 				= 0.0; 
			other_factors 			= { 0.0, 0.0, 0.0 };
			obj_factors 			= {0, 0};
			concrete_factors 		= { 0.0, 0.0, 0.0 };
			cumulative_factor 		= 0;
			concrete_obj_factor 	= 0.0;
			cumulative_thickness 	= 0.0;
			piercing_mass			= 0.0;
			caliber					= 100;
			
			transparency= 0.75,
			color = color_,
			intensity = 1.5,
			duration = 70,
			flare    = false,
		},
		
		targeting_data =
		{
			char_time = 20.540000,    
		},
	}

	declare_weapon(OH58D_Smoke_Grenade)

	declare_loadout(
	{
		category   = CAT_BOMBS,
		CLSID    = weaponname,
		attribute  =  {wsType_Weapon,wsType_Bomb,wsType_Container,WSTYPE_PLACEHOLDER},
		Picture   = "OH58D_Smoke.png",
		displayName  = _(displayname),
		Weight     = 0.5,
		Count	=	1,
		wsTypeOfWeapon = OH58D_Smoke_Grenade.wsTypeOfWeapon,
		kind_of_shipping =  1,
		Elements =
		{
			{
				Position	=	{0.0,	0.0,	0.0}, 
				ShapeName	=	modelname,
			},
		},
	}
	)
end
-- red blue green purple yellow white
make_grenade_load("OH58D_Red_Smoke_Grenade","Red Smoke Grenade","oh58d_SMred",{1,0,0},"1xRed Smoke Grenade")
make_grenade_load("OH58D_Blue_Smoke_Grenade","Blue Smoke Grenade","oh58d_SMblue",{0,0,1},"1xBlue Smoke Grenade")
make_grenade_load("OH58D_Green_Smoke_Grenade","Green Smoke Grenade","oh58d_SMgreen",{0,1,0},"1xGreen Smoke Grenade")
make_grenade_load("OH58D_Violet_Smoke_Grenade","Violet Smoke Grenade","oh58d_SMviolet",{1,0,1},"1xViolet Smoke Grenade")
make_grenade_load("OH58D_Yellow_Smoke_Grenade","Yellow Smoke Grenade","oh58d_SMyellow",{1,1,0},"1xYellow Smoke Grenade")
make_grenade_load("OH58D_White_Smoke_Grenade","White Smoke Grenade","oh58d_SMwhite",{1,1,1},"1xWhite Smoke Grenade")

-- Hellfires
declare_loadout(
{
	category   			= CAT_MISSILES,
	CLSID    				= "OH58D_AGM_114_R1",
	attribute  			= {wsType_Weapon,wsType_Missile,wsType_Container,WSTYPE_PLACEHOLDER},
	wsTypeOfWeapon		= "weapons.missiles.AGM_114K",
	Picture   			= "OH58D_AGM_114.png",
	displayName  			= "1xAGM-114K",
	Cx_pil				=	0.001,
	Weight     			= 45.18+42.18+3.65+2.04, -- Hellfire K 45.18 kg -- Launcher 42.18 kg -- bras armé 3.65 kg -- cablage 2.04 kg
	Count 				= 1,
	Elements  = 
	{
	{
		--Position	=	{0.2689, 0.0, 0.0}, -- marche pas ici ?
		ShapeName	=	"OH58D_HRACK_R",
		IsAdapter   =   true,
	},
	{
		--Position	=	{0.4081,	0.4399,	0.212}, -- ext relatif position pylon
		--Position	=	{fwd/aft,	-up/down,	L/R}, -- ext relatif position pylon
		Position	=	{0.15,	-0.1,	0.165}, -- ext relatif position pylon			--- (0.35,	-0.1,	0.165},
		ShapeName	=	"AGM-114K",
		Rotation    =   {0.0,0.0,0.0},
	},
	-- {
		-- Position	=	{0.403,	-0.13,	-0.17}, -- int relatif position pylon
		-- ShapeName	=	"OH58D_AGM114K",
		-- Rotation    =   {0.0,0.0,0.0},
	-- },
	},
})

declare_loadout(
 {
  category   			= CAT_MISSILES,
  CLSID    				= "OH58D_AGM_114_R",
  attribute  			= {wsType_Weapon,wsType_Missile,wsType_Container,WSTYPE_PLACEHOLDER},
  wsTypeOfWeapon		= "weapons.missiles.AGM_114K",
  Picture   			= "OH58D_AGM_114.png",
  displayName  			= "2xAGM-114K",
  Cx_pil				=	0.001,
  Weight     			= (2*45.18)+42.18+3.65+2.04, -- Hellfire K 45.18 kg -- Launcher 42.18 kg -- bras armé 3.65 kg -- cablage 2.04 kg
  Count 				= 2,
  Elements  = 
  {
	{
		--Position	=	{0.2689, 0.0, 0.0}, -- marche pas ici ?
		ShapeName	=	"OH58D_HRACK_R",
		IsAdapter   =   true,
	},
	{
		--Position	=	{fwd/aft,	-up/down,	L/R}, -- ext relatif position pylon				
		--Position	=	{0.4081,	0.4399,	0.212}, -- ext relatif position pylon
		Position	=	{0.15,	-0.1,	0.165}, -- ext relatif position pylon
		ShapeName	=	"AGM-114K",
		Rotation    =   {0.0,0.0,0.0},
	},
	{
		Position	=	{0.15,	-0.1,	-0.17}, -- int relatif position pylon
		ShapeName	=	"AGM-114K",
		Rotation    =   {0.0,0.0,0.0},
	},
  },
 }
)

declare_loadout(
 {
  category   			= CAT_MISSILES,
  CLSID    				= "OH58D_AGM_114_L1",
  attribute  			= {wsType_Weapon,wsType_Missile,wsType_Container,WSTYPE_PLACEHOLDER},
  wsTypeOfWeapon		= "weapons.missiles.AGM_114K",
  Picture   			= "OH58D_AGM_114.png",
  displayName  			= "1xAGM-114K",
  Cx_pil				= 0.001,
  Weight     			= 45.18+42.18+3.65+2.04, -- Hellfire K 45.18 kg -- Launcher 42.18 kg -- bras armé 3.65 kg -- cablage 2.04 kg
  Count 				= 1,
  Elements  = 
  {
	{
		--Position	=	{0,	0,	0},
		ShapeName	=	"OH58D_HRACK_L",
		IsAdapter   =   true,
	},
	{
		Position	=	{0.15,	-0.1,	-0.165}, -- ext relatif position pylon
		ShapeName	=	"AGM-114K",
		Rotation    =   {0.0,0.0,0.0},
	},
	-- {
		-- Position	=	{0.403,	-0.13,	0.2}, -- int relatif position pylon
		-- ShapeName	=	"OH58D_AGM114K",
		-- Rotation    =   {0.0,0.0,0.0},
	-- },
  },
 }
)

declare_loadout(
 {
  category   			= CAT_MISSILES,
  CLSID    				= "OH58D_AGM_114_L",
  attribute  			= {wsType_Weapon,wsType_Missile,wsType_Container,WSTYPE_PLACEHOLDER},
  wsTypeOfWeapon		= "weapons.missiles.AGM_114K",
  Picture   			= "OH58D_AGM_114.png",
  displayName  			= "2xAGM-114K",
  Cx_pil				=	0.001,
  Weight     			= (2*45.18)+42.18+3.65+2.04, -- Hellfire K 45.18 kg -- Launcher 42.18 kg -- bras armé 3.65 kg -- cablage 2.04 kg
  Count 				= 2,
  Elements  = 
  {
	{
		--Position	=	{0,	0,	0},
		ShapeName	=	"OH58D_HRACK_L",
		IsAdapter   =   true,
	},
	{
		Position	=	{0.15,	-0.1,	-0.165}, -- ext relatif position pylon
		ShapeName	=	"AGM-114K",
		Rotation    =   {0.0,0.0,0.0},
	},
	{
		Position	=	{0.15,	-0.1,	0.17}, -- int relatif position pylon 0.20
		ShapeName	=	"AGM-114K",
		Rotation    =   {0.0,0.0,0.0},
	},
  },
 }
)

----------------------
-- FIM-92
----------------------
local OH58D_FIM_92 = {
	category		= CAT_AIR_TO_AIR,
	name			= "OH58D_FIM_92",
	user_name	 	= _("FIM-92"),
	scheme			= "self_homing_spin_missile2",
	class_name		= "wAmmunitionSelfHoming",
	model			= "OH58D_FIM_92",
	wsTypeOfWeapon  = {wsType_Weapon,wsType_Missile,wsType_AA_Missile,WSTYPE_PLACEHOLDER},
    Escort = 0,
    Head_Type = 1,
	sigma = {3, 3, 3},
    M = 10.1,
    H_max = 3500.0,
    H_min = 1.0,
    Diam = 70.0,
    Cx_pil = 1,
    D_max = 5000.0,
    D_min = 200.0,
    Head_Form = 1,
    Life_Time = 30.0,
    Nr_max = 18,
    v_min = 70.0,
    v_mid = 300.0,
    Mach_max = 2.2,
    t_b = 0.0,
    t_acc = 3.0,
    t_marsh = 3.0,
    Range_max = 6000.0,
    H_min_t = 10.0,
    Fi_start = math.rad(1),
    Fi_rak = 3.14152,
    Fi_excort = 0.7,
    Fi_search = 99.9,
    OmViz_max = 99.9,
    X_back = 0,
    Y_back = 0.0,
    Z_back = 0.0,
    Reflection = 0.01,
    KillDistance = 0.0,
	SeekerSensivityDistance = 10000, -- The range of target with IR value = 1. In meters.
	ccm_k0 					= 0.5,  -- Counter Countermeasures Probability Factor. Value = 0 - missile has absolutely resistance to countermeasures. Default = 1 (medium probability)
	SeekerCooled			= true, -- True is cooled seeker and false is not cooled seeker.	
	
	shape_table_data =
	{
		{
			name		= "OH58D_FIM_92",
			file		= "OH58D_FIM_92",
			life		= 1,
			fire		= { 0, 1},
			username	= _("FIM-92"),
			index		= FIM_92C,
		},
	},

	controller = {
		boost_start = 0,
		march_start = 0.4,
		march2_start = 3.1,
	},

	booster = {
		impulse								= 190,
		fuel_mass							= 0.1,
		work_time							= 0.05,
		boost_time							= 0,
		boost_factor						= 0,
		nozzle_position						= {{-0.79, 0, 0}},
		nozzle_orientationXYZ				= {{0, 0, 0}},
		tail_width							= 0.216,
		smoke_color							= {0.7, 0.7, 0.7},
		smoke_transparency					= 0.9,
		custom_smoke_dissipation_factor		= 0.01,
		max_effect_length					= 10e3,
		-- jettisoned booster params
		model_name					= "mistral_booster", -- TODO replace model
		wind_sigma					= 0.0,
		moment_sigma				= 10.0,
		impulse_sigma				= 1,
		start_impulse				= 1,
		mass						= 1.0,
		caliber						= 0.1,
		L							= 0.1,
		I							= 1,
		Ma							= 0.05,
		Mw							= 1e-4,
		Cx							= 0.9,
	},

	march = {
		impulse								= 232,
		fuel_mass							= 2.52,
		work_time							= 2.7,
		boost_time							= 0,
		boost_factor						= 0,
		nozzle_position						= {{-0.79, 0, 0}},
		nozzle_orientationXYZ				= {{0, 0, 0}},
		tail_width							= 0.216,
		smoke_color							= {0.7, 0.7, 0.7},
		smoke_transparency					= 1,
		custom_smoke_dissipation_factor		= 0.01,
		max_effect_length					= 10e4
	},

	march2 = {
		impulse								= 225,
		fuel_mass							= 2.04,
		work_time							= 5.1,
		boost_time							= 0,
		boost_factor						= 0,
		nozzle_position						= {{-0.79, 0, 0}},
		nozzle_orientationXYZ				= {{0, 0, 0}},
		tail_width							= 0.216,
		smoke_color							= {0.7, 0.7, 0.7},
		smoke_transparency					= 1,
		custom_smoke_dissipation_factor		= 0.01,
		max_effect_length					= 10e4
	},

	fm = {
		mass			= 10.1,
		caliber			= 0.072,
		cx_coeff		= {1, 1.15, 0.8, 0.4, 1.5},
		L				= 1.52,
		I				= 1 / 12 * 10.6 * 1.52 ^ 2,
		Ma				= 0.6,
		Mw				= 1.2,
		Sw				= 0.2,
		dCydA			= {0.07, 0.036},
		A				= 0.6,
		maxAoa			= 0.3,
		finsTau			= 0.1,
		freq			= 20,
	},

	simple_IR_seeker = {
		sensitivity		= 9500,
		cooled			= true,
		delay			= 0,
		FOV				= math.rad(2);
		opTime			= 15,
		target_H_min	= 0,
		flag_dist		= 150,
		abs_err_val		= 2,
		ground_err_k	= 3,
		ccm_k0			= 0.5,
	},

	simple_gyrostab_seeker = {
		omega_max = math.rad(8),
		gimbal_lim = math.rad(30),
	},

	fuze = {
		default_self_destruct_delay	= 17,
		fuze_time_sigma				= 0.9
	},

	autopilot = {
		K				= 2,
		Kg				= 0.1,
		Ki				= 0,
		finsLimit		= 0.2,
		delay 			= 0.5,
		fin2_coeff		= 0.5,
	},

	warhead		= predefined_warhead("FIM_92C"),
	warhead_air	= predefined_warhead("FIM_92C")
}
declare_weapon(OH58D_FIM_92)

declare_loadout(
{
	category 		= CAT_AIR_TO_AIR,
	CLSID	 		= "OH58D_FIM_92_R",
	attribute		= {wsType_Weapon,wsType_Missile,wsType_Container,WSTYPE_PLACEHOLDER},
	wsTypeOfWeapon	= OH58D_FIM_92.wsTypeOfWeapon,
	--wsTypeOfWeapon	= {4,	4,	34,	93},
	Count 			= 2,
	Picture			= "OH58D_FIM_92.png",
	displayName		= "2xFIM-92",
	--Weight			= (2*OH58D_FIM_92.M) + 16.42+3.65+2.13,
	Weight			= (2*10.3) + 16.42+3.65+2.13, -- FIM-92 15.19 kg -- launcher 16.42 kg -- bras armé 3.65 kg -- cablage 2.13 kg
	--Weight			= (2*15.19) + 16.42+3.65+2.13, -- FIM-92 15.19 kg -- launcher 16.42 kg -- bras armé 3.65 kg -- cablage 2.13 kg
	Cx_pil			= 0.001,
	Elements		=
	{
		{
			ShapeName	=	"OH58D_SRACK_R",
			IsAdapter   =   true,
		},
		{
			ShapeName	=	"OH58D_FIM_92",
			connector_name = "ATAS_pt002",
		}, 
		{
			ShapeName	=	"OH58D_FIM_92",
			connector_name = "ATAS_pt1",
		}, 
	},
}
)

declare_loadout(
{
	category 		= CAT_AIR_TO_AIR,
	CLSID	 		= "OH58D_FIM_92_L",
	attribute		= {wsType_Weapon,wsType_Missile,wsType_Container,WSTYPE_PLACEHOLDER},
	wsTypeOfWeapon	= OH58D_FIM_92.wsTypeOfWeapon,
	--wsTypeOfWeapon	= {4,	4,	34,	93},
	Count 			= 2,
	Picture			= "OH58D_FIM_92.png",
	displayName		= "2xFIM-92",
	--Weight			= (2*OH58D_FIM_92.M) + + 16.42+3.65+2.13,
	--Weight			= (2*15.19) + 16.42+3.65+2.13, -- FIM-92 15.19 kg -- launcher 16.42 kg -- bras armé 3.65 kg -- cablage 2.13 kg
	Weight			= (2*10.3) + 16.42+3.65+2.13, -- FIM-92 15.19 kg -- launcher 16.42 kg -- bras armé 3.65 kg -- cablage 2.13 kg
	Cx_pil			= 0.001,
	Elements		=
	{
		{
			ShapeName	=	"OH58D_SRACK_L",
			IsAdapter   =   true,
		},
		{
			ShapeName	=	"OH58D_FIM_92",
			connector_name = "ATAS_pt1",
		}, 
		{
			ShapeName	=	"OH58D_FIM_92",
			connector_name = "ATAS_pt002",
		} 
	},
}
)

--M3P
function M3P_Mount(tbl)

	tbl.category	= CAT_GUN_MOUNT 
	tbl.name		= "OH58D_M3P"
	tbl.supply		= 
	{
		shells	= {
					"M2_12_7",
					"M2_12_7_T", 
					"M242_25_HE_M792"
				 },
		mixes	= {
					{1},
					{2},
					{3},
				}, 
		count	= 500,
	}
	if tbl.mixes then 
	   tbl.supply.mixes =  tbl.mixes
	   tbl.mixes	    = nil
	end
	if tbl.count then 
	   tbl.supply.count =  tbl.count
	   tbl.count	    = nil
	end
	tbl.gun = 
	{
		max_burst_length = 400,
		rates 			 = {1025},
		recoil_coeff 	 = 1,
		barrels_count 	 = 1,
	}
	if tbl.rates then 
	   tbl.gun.rates    =  tbl.rates
	   tbl.rates	    = nil
	end	
	tbl.ejector_pos 			= tbl.ejector_pos or {-1.099, -0.173, 0.101}
	tbl.ejector_dir 			= {0,0,-1}
	tbl.supply_position  		= tbl.supply_position or {0,  0.3, -0.3}
	tbl.aft_gun_mount 			= false
	tbl.effective_fire_distance = 3000
	tbl.drop_cartridge 			= 204
	tbl.muzzle_pos				= tbl.muzzle_pos or  {0,0,0} -- all position from connector
	tbl.muzzle_pos_connector	= tbl.muzzle_pos_connector or  "Point_Gun" -- all position from connector
	tbl.azimuth_initial 		= tbl.azimuth_initial    or 0
	tbl.elevation_initial 		= tbl.elevation_initial  or 0

	if  tbl.effects == nil then
		tbl.effects =
		{
			{ name = "FireEffect"     , arg = tbl.effect_arg_number or 436 },
			{ name = "HeatEffectExt"  , shot_heat = 7.823, barrel_k = 0.462 * 2.7, body_k = 0.462 * 14.3 },
			{ name = "SmokeEffect"},
			{ name = "TurretRecoil",   recoil_arg = 350, spring_coeff = 0.3, recoil_coeff = 0.95 }
		}
	end
	
	return declare_weapon(tbl)
end

function declare_m3p(CLSID, displayName, picture, ammoCount, shapeName)
	declare_loadout(
		{
			category			= CAT_PODS,
			CLSID				= CLSID,
			displayName			= _(displayName),
			Picture				= picture,
			attribute			= {wsType_Weapon, wsType_GContainer, wsType_Cannon_Cont, WSTYPE_PLACEHOLDER},
			wsTypeOfWeapon		= {wsType_Weapon, wsType_Shell, wsType_Shell_A, wsTypeVulkan},
			Weight				= (ammoCount/100 * 13.318) + 37.42+9.34+19.1+2.22+3.65+0.82, -- INCLUDE AMMO FOR FULL WEIGHT
			Weight_Empty        = 37.42+9.34+19.1+2.22+3.65+0.82,
			Cx_pil				= 0,
			kind_of_shipping	= 2,--SOLID_MUNITION
			gun_mounts			=
			{
				M3P_Mount(
				{
					mixes					= {{1, 1, 1, 1, 2}},
					muzzle_pos				= {0.0, 0.0, 0.0},
					count					= ammoCount,
					muzzle_pos_connector	= "Point_Gun",
					azimuth_initial			= 0.0, -- -0.04363323, -- 2.5 degs to the left
					effect_arg_number		= 433,
				})
			},
			shape_table_data =
			{
				{
					name		= shapeName;
					file		= "oh58d_m3p";
					life		= 1;
					fire		= {0, 1};
					username	= shapeName;
					index		= WSTYPE_PLACEHOLDER;
				},
			},
			Elements =
			{
				[1]	=
				{
					Position	=	{0, 0, 0},
					ShapeName	=	"oh58d_m3p",
				}, 
			}, -- end of Elements
		}
	)
end

declare_m3p("OH58D_M3P_L500", "M3P500", "OH58D_M3P500.png", 500, "M3P500")
declare_m3p("OH58D_M3P_L400", "M3P400", "OH58D_M3P400.png", 400, "M3P400")
declare_m3p("OH58D_M3P_L300", "M3P300", "OH58D_M3P300.png", 300, "M3P300")
declare_m3p("OH58D_M3P_L200", "M3P200", "OH58D_M3P200.png", 200, "M3P200")
declare_m3p("OH58D_M3P_L100", "M3P100", "OH58D_M3P100.png", 100, "M3P100")

-- CPG M4
function CPG_M4(tbl)

	tbl.category = CAT_GUN_MOUNT 
	tbl.name 	 = "CPG_M4"
	tbl.supply 	 = 
	{
		--shells = {"S762_51","S762_51T"},
		--mixes = {{4,2}},
		--shells = {"S762_51"},
		shells = {"5_56x45", "5_56x45_NOtr", "5_56x45_NOtr"},
		count  = 150,
	}
	if tbl.mixes then 
	   tbl.supply.mixes =  tbl.mixes
	   tbl.mixes	    = nil
	end
	tbl.gun = 
	{
		max_burst_length = 30, --ANDR0ID Edit from 3
		rates 			 = {850},
		recoil_coeff 	 = 0.01, -- 0.5*1.3, -- 0.7*1.3 -- 0.2*1.3
		barrels_count 	 = 1,
	}
	-- if tbl.rates then 
	   -- tbl.gun.rates    =  tbl.rates
	   -- tbl.rates	    = nil
	-- end	
	tbl.ejector_pos 			= tbl.ejector_pos or {0.579,0.142,-0.629} -- relatif muzzle (lon,lat,vert)
	tbl.ejector_pos_connector 	= tbl.ejector_pos_connector or "oh58d_M4_brass"
	tbl.ejector_dir 			= {0,0,1}
	tbl.supply_position  		= tbl.supply_position   or {-0.3,-1.0, 0.0} -- relatif muzzle (lon,lat,vert)
	tbl.aft_gun_mount 			= false
	tbl.effective_fire_distance = 500
	tbl.drop_cartridge 			= 205 -- cartridge_308cal 
	tbl.muzzle_pos				= tbl.muzzle_pos 		 or  {0.579,0.142,-0.629} -- position repère (lon,vert,lat)
	tbl.muzzle_pos_connector	= tbl.muzzle_pos_connector	or  "oh58d_M4_muzzle" -- all position from connector
	tbl.azimuth_initial 		= tbl.azimuth_initial    or 0
	tbl.elevation_initial 		= tbl.elevation_initial  or 0
	tbl.barrel_circular_error	= 0.002
	if  tbl.effects == nil then
		tbl.effects =
		{
			{
				name = "FireEffect",
				arg = tbl.effect_arg_number or 436,
				attenuation = 1.0,
			},
			--{ name = "HeatEffectExt"  , shot_heat = 7.823, barrel_k = 0.462 * 2.7, body_k = 0.462 * 14.3 },
			--{ name = "SmokeEffect"}
		}
	end
	
end

function CPG_M4_VR(tbl)
	CPG_M4(tbl)
	return declare_weapon(tbl)
end

function CPG_M4_NON_VR(tbl)
	CPG_M4(tbl)
	tbl.muzzle_pos_connector = "oh58d_M4_muzzle_novr"
	tbl.ejector_pos_connector = "oh58d_M4_brass_novr"
	return declare_weapon(tbl)
end

--ANDR0ID Added 

local M282_MPP_REDUX = {
	category			= CAT_ROCKETS,
	name				= "M282_MPP_REDO",
	user_name			= "M282_MPP_REDO",
	wsTypeOfWeapon		= {wsType_Weapon,wsType_NURS,wsType_Rocket,WSTYPE_PLACEHOLDER},
	scheme 				= "nurs-standard",
	model 				= "hydra_m282",

        fm = predefined_fm("Hydra70"),
        --[[{
            mass        = 12.4,   -- start weight, kg
            caliber     = 0.07, -- Caliber, meters 
            cx_coeff    = { 1, 1.5, 0.68, 0.7, 1.75 },  -- Cx
            L           = 1.472, --Length, meters
            I           = 2.2390101333333, -- moment of inertia
            Ix          = 6, -- not used???
            Ma          = 0.23322, -- dependence moment coefficient of  by  AoA
            Mw          = 2.177036, --  dependence moment coefficient by angular speed
            shapeName   = "",
            
            wind_time   = 1.1, -- dispersion coefficient
            wind_sigma  = 5, -- dispersion coefficient
        },]]

        engine = predefined_engine("Mk66"),
        --[[{
            fuel_mass   = 3.175, -- Fuel mass, kg
            impulse     = 210, -- Specific impulse, sec
            boost_time  = 0, -- Time of booster action
            work_time   = 1.1, -- Time of mid-flight engine action
            boost_factor= 1, -- Booster to cruise trust ratio
            nozzle_position = {{ -0.65, 0, 0 }}, -- meters
            tail_width  = 0.052, -- contrail thickness 
            boost_tail  = 1,
            work_tail   = 1,

            smoke_color = { 0.5, 0.474, 0.443 },
			smoke_transparency = 0.5,
        },]]

	warhead	= predefined_warhead("HYDRA_70_M282"),
	--[[{
		mass	= 6.2,
		expl_mass = 0.44,
		other_factors = { 1.17, 1.17, 1.17 },
		concrete_factors = { 1.17, 1.17, 0.1 },
		concrete_obj_factor = 0.5,
		obj_factors = { 1.17, 1.17 },
		cumulative_factor= 0,
		cumulative_thickness = 0,
		piercing_mass			= 6.2,
	},]]

	shape_table_data =
	{
		{
			file		 = "hydra_m282",
			life		 = 1,
			fire		 = {0, 1},
			username = "M282_MPP_REDUX",
			index = WSTYPE_PLACEHOLDER,
		},
	},

	properties =
	{
		dist_min = 500,
		dist_max = 4000,
	}
}

declare_weapon(M282_MPP_REDUX)

declare_loadout({ 						--ANDR0ID, this loadout allows the mod defined MPP rockets to be in a mixed configuration by assigning them a CLSID for use in a different loadout
	category 			= CAT_ROCKETS, 
	CLSID	 			= "{M282_MPP}",
	Picture				= "LAU68.png",
	Cx_pil				= 0.001708984375,
	displayName			= "Hydra, M282, MPP",
	Weight				= 12.4,
	Weight_Empty		= 12.4,
	Count				= 1,
	kind_of_shipping	= 0,
	attribute			= {wsType_Weapon, wsType_NURS, wsType_Container, WSTYPE_PLACEHOLDER},
	wsTypeOfWeapon = M282_MPP_REDUX.wsTypeOfWeapon,
	Elements			= {{ ShapeName = "hydra_m282", },
	}
})

declare_loadout({
	category 			= CAT_ROCKETS,
	CLSID	 			= "{M260_M282_MPP_A}",
	Picture				= "LAU68.png",
	Cx_pil				= 0.001708984375,
	displayName			= "M260 - 7 x UnGd Rkts, 70 mm Hydra 70 M282 MPP",
	Weight				= (15.9 + (12.4*7)),
	Weight_Empty		= 15.9,
	Count				= 7,
	kind_of_shipping	= 0,
	attribute			= {wsType_Weapon, wsType_NURS, wsType_Container, WSTYPE_PLACEHOLDER},
	wsTypeOfWeapon = M282_MPP_REDUX.wsTypeOfWeapon,
	Elements			= {{ ShapeName = "OH58D_M260", IsAdapter = true, },
	{ connector_name = "tube_01", payload_CLSID = "{M282_MPP}"},
	{ connector_name = "tube_02", payload_CLSID = "{M282_MPP}"},
	{ connector_name = "tube_03", payload_CLSID = "{M282_MPP}"},
	{ connector_name = "tube_04", payload_CLSID = "{M282_MPP}"},
	{ connector_name = "tube_05", payload_CLSID = "{M282_MPP}"},
	{ connector_name = "tube_06", payload_CLSID = "{M282_MPP}"},
	{ connector_name = "tube_07", payload_CLSID = "{M282_MPP}"},
	}
})

local AGR_20_M282_REDUX =
{
	category		= CAT_MISSILES,
	name			= "AGR_20_M282_REDUX",
	user_name		= _("HYDRA 70 MPP APKWS"),
	display_name_short = "APKWS",
	scheme			= "APKWS",
	class_name		= "wAmmunitionLaserHoming",
	model			= "AGR_20",
	
	wsTypeOfWeapon 	= {wsType_Weapon,wsType_Missile,wsType_AS_Missile,WSTYPE_PLACEHOLDER},
	
	mass			= 17,
	Escort			= 1,
	Head_Type		= 4,
	sigma			= {1, 1, 1},
	H_max			= 5000.0,
	H_min			= 1.0,
	Diam			= 70.0,
	Cx_pil			= 0.00244140625,
	D_max			= 5000.0,
	D_min			= 1000.0,
	Head_Form		= 1,
	Life_Time		= 90.0,
	Nr_max			= 25,
	v_min			= 140.0,
	v_mid			= 350.0,
	Mach_max		= 3.0,
	t_b				= 0.0,
	t_acc			= 0.0,
	t_marsh			= 1.1,
	Range_max		= 5000.0,
	H_min_t			= 15.0,
	Fi_start		= 0.4,
	Fi_rak			= 3.14152,
	Fi_excort		= 1.05,
	Fi_search		= 0.7,
	OmViz_max		= 0.35,
	exhaust			= {0.78, 0.78, 0.78, 0.3};
	X_back			= -2.0,
	Y_back			= -0.0,
	Z_back			= 0.0,
	Reflection		= 0.01,
	KillDistance	= 0.0,
	M				= 15,
	
	warhead		= predefined_warhead("HYDRA_70_M282"),
	
	shape_table_data =
	{
		{
			name  = "AGR_20_M282_REDUX";
			file  = "AGR_20";
			life  = 1;
			fire  = { 0, 1};
			username = _("APKWS M282"),
			index 	 = WSTYPE_PLACEHOLDER,
		},
	},
	
	march = {
		fuel_mass   			= 3.175,
		impulse     			= 210,
		boost_time  			= 0,
		work_time   			= 1.1,
		boost_factor			= 1,
		nozzle_position 	    = {{-0.95, 0, 0}},
		nozzle_orientationXYZ   = {{0, 0, 0}},
		tail_width  			= 0.052,
		boost_tail  			= 1,
		work_tail   			= 1,
		smoke_color				= {0.5, 0.474, 0.443},
		smoke_transparency		= 0.5,
		custom_smoke_dissipation_factor		= 0.2,		
	},

	fm = {
		mass        = 17,  
		caliber     = 0.07, 
		cx_coeff    = {1, 1.5, 0.68, 0.7, 1.75},
		L           = 1.81,
		I           = 1 / 12 * 15 * 1.81 * 1.81,
		Ma          = 0.84,
		Mw          = 3.5,
		shapeName   = "AGR_20",
		wind_sigma	= 5.0,
		wind_time	= 1.1,
		dCydA		= {0.11, 0.11},
		A			= 0.36,
		Sw			= 0.04,
		maxAoa		= math.rad(8),		
		finsTau		= 0.1,
		Mx0			= 0.2,
		Ma_x		= 1.8,
		Mw_x		= 1.12,
		I_x			= 1.01,
	},
	
	seeker = {
		delay				= 1.1,
		FOV					= math.rad(40),
		max_seeker_range	= 13000,
	},

	autopilot = {
		delay				= 0.9,
		op_time				= 45,
		dV_dt				= 20,
		Knav				= 12,
		Tf					= 0.2,
		Kd					= 150,
		Kdx					= 0.2,
		Kix					= 0.8,
		gload_limit			= 10,
		fins_limit			= math.rad(20),
		fins_limit_x		= math.rad(10),
	},
}

declare_weapon(AGR_20_M282_REDUX)

declare_loadout({ 						--ANDR0ID, this loadout allows the mod defined APKWS rockets to be in a mixed configuration by assigning them a CLSID for use in a different loadout
	category 			= CAT_ROCKETS, 
	CLSID	 			= "{APKWS_M282_MPP}",
	Picture				= "LAU68.png",
	Cx_pil				= 0.001708984375,
	displayName			= "Hydra, APKWS M282, MPP",
	Weight				= 17,
	Weight_Empty		= 17,
	Count				= 1,
	kind_of_shipping	= 0,
	attribute			= {wsType_Weapon, wsType_NURS, wsType_Container, WSTYPE_PLACEHOLDER},
	wsTypeOfWeapon = AGR_20_M282_REDUX.wsTypeOfWeapon,
	Elements			= {{ ShapeName = "AGR_20", },
	}
})

declare_loadout({
	category 			= CAT_ROCKETS,
	CLSID	 			= "{M260_M282_MPP_B_APKWS}",
	Picture				= "LAU68.png",
	Cx_pil				= 0.001708984375,
	displayName			= "M260 - 7 x Laser Guided Rkts, 70 mm Hydra 70 M282 MPP APKWS",
	Weight				= (15.9 + (17*7)),
	Weight_Empty		= 15.9,
	Count				= 7,
	kind_of_shipping	= 0,
	attribute			= {wsType_Weapon, wsType_NURS, wsType_Container, WSTYPE_PLACEHOLDER},
	wsTypeOfWeapon = AGR_20_M282_REDUX.wsTypeOfWeapon,
	Elements			= {{ ShapeName = "OH58D_M260", IsAdapter = true, },
	{ connector_name = "tube_01", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_02", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_03", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_04", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_05", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_06", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_07", payload_CLSID = "{APKWS_M282_MPP}"},
	}
})

declare_loadout({
	category 			= CAT_ROCKETS,
	CLSID	 			= "{M260_M282_MPP_C_APKWS}",
	Picture				= "LAU68.png",
	Cx_pil				= 0.001708984375,
	displayName			= "M260 - 7 x Mixed Rkts, 70 mm Hydra 70, Pod Zones: A - M282; B - APKWS",
	Weight				= (15.9 + (17*7)),
	Weight_Empty		= 15.9,
	Count				= 7,
	kind_of_shipping	= 0,
	attribute			= {wsType_Weapon, wsType_NURS, wsType_Container, WSTYPE_PLACEHOLDER},
	wsTypeOfWeapon = AGR_20_M282_REDUX.wsTypeOfWeapon,
	Elements			= {{ ShapeName = "OH58D_M260", IsAdapter = true, },
	{ connector_name = "tube_01", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_02", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_03", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_04", payload_CLSID = "{M282_MPP}"},
	{ connector_name = "tube_05", payload_CLSID = "{M282_MPP}"},
	{ connector_name = "tube_06", payload_CLSID = "{M282_MPP}"},
	{ connector_name = "tube_07", payload_CLSID = "{M282_MPP}"},
	}
})

declare_loadout({
	category 			= CAT_ROCKETS,
	CLSID	 			= "{M260_M282_MPP_D_APKWS}",
	Picture				= "LAU68.png",
	Cx_pil				= 0.001708984375,
	displayName			= "M260 - 7 x Mixed Rkts, 70 mm Hydra 70, Pod Zones: A - APKWS; B - M282",
	Weight				= (15.9 + (17*7)),
	Weight_Empty		= 15.9,
	Count				= 7,
	kind_of_shipping	= 0,
	attribute			= {wsType_Weapon, wsType_NURS, wsType_Container, WSTYPE_PLACEHOLDER},
	wsTypeOfWeapon = AGR_20_M282_REDUX.wsTypeOfWeapon,
	Elements			= {{ ShapeName = "OH58D_M260", IsAdapter = true, },
	{ connector_name = "tube_01", payload_CLSID = "{M282_MPP}"},
	{ connector_name = "tube_02", payload_CLSID = "{M282_MPP}"},
	{ connector_name = "tube_03", payload_CLSID = "{M282_MPP}"},
	{ connector_name = "tube_04", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_05", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_06", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_07", payload_CLSID = "{APKWS_M282_MPP}"},
	}
})

declare_loadout({
	category 			= CAT_ROCKETS,
	CLSID	 			= "{M260_M282_MPP_E_APKWS}",
	Picture				= "LAU68.png",
	Cx_pil				= 0.001708984375,
	displayName			= "M260 - 3 x Laser Guided Rkts, 70 mm Hydra 70, M282 MPP APKWS",
	Weight				= (15.9 + (17*3)),
	Weight_Empty		= 15.9,
	Count				= 3,
	kind_of_shipping	= 0,
	attribute			= {wsType_Weapon, wsType_NURS, wsType_Container, WSTYPE_PLACEHOLDER},
	wsTypeOfWeapon = AGR_20_M282_REDUX.wsTypeOfWeapon,
	Elements			= {{ ShapeName = "OH58D_M260", IsAdapter = true, },
	{ connector_name = "tube_01", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_02", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_03", payload_CLSID = "{APKWS_M282_MPP}"},
	}
})

declare_loadout({
	category 			= CAT_ROCKETS,
	CLSID	 			= "{M260_M282_MPP_F_APKWS}",
	Picture				= "LAU68.png",
	Cx_pil				= 0.001708984375,
	displayName			= "M260 - 4 x Laser Guided Rkts, 70 mm Hydra 70, M282 MPP APKWS",
	Weight				= (15.9 + (12.4*4)),
	Weight_Empty		= 15.9,
	Count				= 4,
	kind_of_shipping	= 0,
	attribute			= {wsType_Weapon, wsType_NURS, wsType_Container, WSTYPE_PLACEHOLDER},
	wsTypeOfWeapon = AGR_20_M282_REDUX.wsTypeOfWeapon,
	Elements			= {{ ShapeName = "OH58D_M260", IsAdapter = true, },
	{ connector_name = "tube_04", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_05", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_06", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_07", payload_CLSID = "{APKWS_M282_MPP}"},
	}
})

declare_loadout({
	category 			= CAT_ROCKETS,
	CLSID	 			= "{M260_M282_MPP_G}",
	Picture				= "LAU68.png",
	Cx_pil				= 0.001708984375,
	displayName			= "M260 - 3 x UnGd Rkts, 70 mm Hydra 70 M282 MPP",
	Weight				= (15.9 + (12.4*3)),
	Weight_Empty		= 15.9,
	Count				= 3,
	kind_of_shipping	= 0,
	attribute			= {wsType_Weapon, wsType_NURS, wsType_Container, WSTYPE_PLACEHOLDER},
	wsTypeOfWeapon = M282_MPP_REDUX.wsTypeOfWeapon,
	Elements			= {{ ShapeName = "OH58D_M260", IsAdapter = true, },
	{ connector_name = "tube_01", payload_CLSID = "{M282_MPP}"},
	{ connector_name = "tube_02", payload_CLSID = "{M282_MPP}"},
	{ connector_name = "tube_03", payload_CLSID = "{M282_MPP}"},
	}
})

declare_loadout({
	category 			= CAT_ROCKETS,
	CLSID	 			= "{M260_M282_MPP_H}",
	Picture				= "LAU68.png",
	Cx_pil				= 0.001708984375,
	displayName			= "M260 - 4 x UnGd Rkts, 70 mm Hydra 70 M282 MPP",
	Weight				= (15.9 + (17*4)),
	Weight_Empty		= 15.9,
	Count				= 4,
	kind_of_shipping	= 0,
	attribute			= {wsType_Weapon, wsType_NURS, wsType_Container, WSTYPE_PLACEHOLDER},
	wsTypeOfWeapon = M282_MPP_REDUX.wsTypeOfWeapon,
	Elements			= {{ ShapeName = "OH58D_M260", IsAdapter = true, },
	{ connector_name = "tube_04", payload_CLSID = "{M282_MPP}"},
	{ connector_name = "tube_05", payload_CLSID = "{M282_MPP}"},
	{ connector_name = "tube_06", payload_CLSID = "{M282_MPP}"},
	{ connector_name = "tube_07", payload_CLSID = "{M282_MPP}"},
	}
})

declare_loadout({
	category 			= CAT_ROCKETS,
	CLSID	 			= "{M260_M282_MPP_I_APKWS}",
	Picture				= "LAU68.png",
	Cx_pil				= 0.001708984375,
	displayName			= "M260 - 7 x Mixed Rkts, 70 mm Hydra 70, Pod Zones: A - M257; B - APKWS",
	Weight				= (15.9 + (17*7)),
	Weight_Empty		= 15.9,
	Count				= 7,
	kind_of_shipping	= 0,
	attribute			= {wsType_Weapon, wsType_NURS, wsType_Container, WSTYPE_PLACEHOLDER},
	wsTypeOfWeapon = AGR_20_M282_REDUX.wsTypeOfWeapon,
	Elements			= {{ ShapeName = "OH58D_M260", IsAdapter = true, },
	{ connector_name = "tube_01", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_02", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_03", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_04", payload_CLSID = "{M257_HYDRA}"},
	{ connector_name = "tube_05", payload_CLSID = "{M257_HYDRA}"},
	{ connector_name = "tube_06", payload_CLSID = "{M257_HYDRA}"},
	{ connector_name = "tube_07", payload_CLSID = "{M257_HYDRA}"},
	}
})

declare_loadout({
	category 			= CAT_ROCKETS,
	CLSID	 			= "{M260_M282_MPP_J_APKWS}",
	Picture				= "LAU68.png",
	Cx_pil				= 0.001708984375,
	displayName			= "M260 - 7 x Mixed Rkts, 70 mm Hydra 70, Pod Zones: A - APKWS; B - M257",
	Weight				= (15.9 + (17*7)),
	Weight_Empty		= 15.9,
	Count				= 7,
	kind_of_shipping	= 0,
	attribute			= {wsType_Weapon, wsType_NURS, wsType_Container, WSTYPE_PLACEHOLDER},
	wsTypeOfWeapon = AGR_20_M282_REDUX.wsTypeOfWeapon,
	Elements			= {{ ShapeName = "OH58D_M260", IsAdapter = true, },
	{ connector_name = "tube_01", payload_CLSID = "{M257_HYDRA}"},
	{ connector_name = "tube_02", payload_CLSID = "{M257_HYDRA}"},
	{ connector_name = "tube_03", payload_CLSID = "{M257_HYDRA}"},
	{ connector_name = "tube_04", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_05", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_06", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_07", payload_CLSID = "{APKWS_M282_MPP}"},
	}
})
	
declare_loadout({
	category 			= CAT_ROCKETS,
	CLSID	 			= "{M260_M282_MPP_K_APKWS}",
	Picture				= "LAU68.png",
	Cx_pil				= 0.001708984375,
	displayName			= "M260 - 7 x Mixed Rkts, 70 mm Hydra 70, Pod Zones: A - M259; B - APKWS",
	Weight				= (15.9 + (17*7)),
	Weight_Empty		= 15.9,
	Count				= 7,
	kind_of_shipping	= 0,
	attribute			= {wsType_Weapon, wsType_NURS, wsType_Container, WSTYPE_PLACEHOLDER},
	wsTypeOfWeapon = AGR_20_M282_REDUX.wsTypeOfWeapon,
	Elements			= {{ ShapeName = "OH58D_M260", IsAdapter = true, },
	{ connector_name = "tube_01", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_02", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_03", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_04", payload_CLSID = "{M259_HYDRA}"},
	{ connector_name = "tube_05", payload_CLSID = "{M259_HYDRA}"},
	{ connector_name = "tube_06", payload_CLSID = "{M259_HYDRA}"},
	{ connector_name = "tube_07", payload_CLSID = "{M259_HYDRA}"},
	}
})

declare_loadout({
	category 			= CAT_ROCKETS,
	CLSID	 			= "{M260_M282_MPP_L_APKWS}",
	Picture				= "LAU68.png",
	Cx_pil				= 0.001708984375,
	displayName			= "M260 - 7 x Mixed Rkts, 70 mm Hydra 70, Pod Zones: A - APKWS; B - M259",
	Weight				= (15.9 + (17*7)),
	Weight_Empty		= 15.9,
	Count				= 7,
	kind_of_shipping	= 0,
	attribute			= {wsType_Weapon, wsType_NURS, wsType_Container, WSTYPE_PLACEHOLDER},
	wsTypeOfWeapon = AGR_20_M282_REDUX.wsTypeOfWeapon,
	Elements			= {{ ShapeName = "OH58D_M260", IsAdapter = true, },
	{ connector_name = "tube_01", payload_CLSID = "{M259_HYDRA}"},
	{ connector_name = "tube_02", payload_CLSID = "{M259_HYDRA}"},
	{ connector_name = "tube_03", payload_CLSID = "{M259_HYDRA}"},
	{ connector_name = "tube_04", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_05", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_06", payload_CLSID = "{APKWS_M282_MPP}"},
	{ connector_name = "tube_07", payload_CLSID = "{APKWS_M282_MPP}"},
	}
})
	
function OH58_GAU19(tbl) --GAU-19 originally by nibbylot

	tbl.category = CAT_GUN_MOUNT 
	tbl.name 	 = "OH58 GAU-19"
	tbl.supply 	 = 
	{
		shells = {"50Browning_API_M8","50Browning_APIT_M20"}, 
		mixes  = {{2,1,1,1,1}}, 
		count  = 500,
	}
	if tbl.mixes then 
	   tbl.supply.mixes =  tbl.mixes
	   tbl.mixes	    = nil
	end
	tbl.gun = 
	{
		max_burst_length = 500,
		rates 			 = {1300},
		recoil_coeff 	 = 0.25*1.3,
		barrels_count 	 = 3,
	}
	if tbl.rates then 
	   tbl.gun.rates    =  tbl.rates
	   tbl.rates	    = nil
	end	
	tbl.ejector_pos 			= {-1.072, -0.05, -0.039} -- position from muzzle connector pos
	tbl.ejector_dir 			= tbl.ejector_dir
	tbl.supply_position  		= tbl.supply_position or {0,  0.3, -0.3}
	tbl.aft_gun_mount 			= false
	tbl.effective_fire_distance = 1800
	tbl.drop_cartridge 			= 204 -- drop shell shape/size from  aircraft_gun_mounts.lua
	tbl.muzzle_pos				= tbl.muzzle_pos or {0,0,0} -- all position from connector
	tbl.muzzle_pos_connector	= tbl.muzzle_pos_connector 	or  "Gun_point" -- all position from connector
	tbl.azimuth_initial 		= tbl.azimuth_initial    or 0   
	tbl.elevation_initial 		= tbl.elevation_initial  or 0   
	if  tbl.effects == nil then
		tbl.effects = {{ name = "FireEffect"     , arg 		 = tbl.effect_arg_number or 436 },
					   { name = "HeatEffectExt"  , shot_heat = 7.823, barrel_k = 0.462 * 2.7, body_k = 0.462 * 14.3 },
					   { name = "SmokeEffect"},
					   { name = "GatlingEffect", arg = 44, barrels_n = 3, spin_up_t = 0.4, spin_down_t = 0.1}
					   }
	end
	return declare_weapon(tbl)
end

declare_loadout({
	category 		=   CAT_PODS,
	CLSID	 		=  "{OH58_GAU-19}",
	attribute		=   {wsType_Weapon,wsType_GContainer,wsType_Cannon_Cont,WSTYPE_PLACEHOLDER},
	wsTypeOfWeapon	= 	{wsType_Weapon,wsType_Shell,wsType_Shell,WSTYPE_PLACEHOLDER},
	Picture			=	"m134.png",
	displayName		=	_("GAU-19 .50 Cal, 500 rounds"),-- loadout editor name
	Weight			=	63+9.34+19.1+2.22+3.65+0.82+(500/100 * 13.318), --loaded	63kg empty gun 
	Weight_Empty    =   63+9.34+19.1+2.22+3.65+0.82,
	Cx_pil			=	0.00024,
	Elements  		= {{ShapeName = "OH58_GAU19"}},
	kind_of_shipping = 2,--SOLID_MUNITION
	gun_mounts		= {
			OH58_GAU19({
				ejector_dir = {0,-1,-0.5},
				supply_position = {2, -0.3, -0.4}
			})			
	},	
	shape_table_data = {{file  	 = 'OH58_GAU19';	username = 'OH58_GAU-19_gun'; index = WSTYPE_PLACEHOLDER;}}
})

function OH58_M134P(tbl) --M134 originally by Tanuki44
    tbl.category = CAT_GUN_MOUNT
    tbl.name     = "OH58 M134"
    tbl.supply = 
	{ 
		shells = {"7_62x51","7_62x51tr"},
		mixes  = {{2,1,1}},--{{2,1,1,1,1}}, 
        count = 3000, --Based on Dillon Aero 3000 round magazine for Kiowa Warrior 
    }
    if tbl.mixes then
        tbl.supply.mixes = tbl.mixes
        tbl.mixes = nil
    end
    tbl.gun =
    {
        max_burst_length    = 3000, 
        rates               = {3000}, --M134D Fixed firing rate of 3000 rpm
        recoil_coeff        = 0.01,
        barrels_count       = 6,
    }
    if tbl.rates then
       tbl.gun.rates        =  tbl.rates
       tbl.rates            = nil
    end
    tbl.ejector_pos             = tbl.ejector_pos or {0.0, -0.9, 0}
    tbl.ejector_pos_connector   = tbl.ejector_pos_connector or {0.0, -0.9, 0}
    tbl.ejector_dir             = {-1, -6, 0}
    tbl.supply_position         = tbl.supply_position or {0,  0.3, -0.3}
    tbl.aft_gun_mount           = false
    tbl.effective_fire_distance = 1500
    tbl.drop_cartridge          = 204
    tbl.muzzle_pos              = tbl.muzzle_pos            or  {0,0,0}     -- all position from connector
    tbl.muzzle_pos_connector    = tbl.muzzle_pos_connector  or  {0,0,0} 	-- all position from connector
    tbl.azimuth_initial         = tbl.azimuth_initial       or  0
    tbl.elevation_initial       = tbl.elevation_initial     or  0 ---5
    if  tbl.effects == nil then
        tbl.effects = {{ name = "FireEffect"     , arg = tbl.effect_arg_number or 436 },
                       { name = "HeatEffectExt"  , shot_heat = 7.823, barrel_k = 1.2474, body_k = 6.6066 },
					   { name = "GatlingEffect", arg = 53, barrels_n = 6, spin_up_t = 0.2, spin_down_t = 0.1},
                       { name = "SmokeEffect"}
					}
    end
    return declare_weapon(tbl)
end

declare_loadout({
	category 		=   CAT_PODS,
	CLSID	 		=  "{OH-58_M134P_3000}",
	attribute		=   {wsType_Weapon,wsType_GContainer,wsType_Cannon_Cont,WSTYPE_PLACEHOLDER},
	wsTypeOfWeapon	= 	{wsType_Weapon,wsType_Shell,wsType_Shell,WSTYPE_PLACEHOLDER},
	Picture			=	"m134.png",
	displayName		=	_("M134 7.62mm, 3000 rounds"),-- loadout editor name
	Weight			=   39+9.34+19.1+2.22+3.65+0.82+(3000*0.00933), --loaded	39kg empty gun 
	Weight_Empty    =   39+9.34+19.1+2.22+3.65+0.82,
	Cx_pil			=	0.00024,
	Elements  		= {{ShapeName = "OH58_m134_pylon"}},	
	kind_of_shipping = 2,--SOLID_MUNITION
	gun_mounts		= {
        OH58_M134P({
			supply_position         = {0.65, -0.27, 0},
			muzzle_pos              = {0.65, -0.27, 0},
			muzzle_pos_connector    = {0.65, -0.27, 0},
			elevation_initial		= 0, --Changed from -4 to 0 for KW
			--count					= 3000,
		})
	},	
	shape_table_data = {{file = 'OH58_m134_pylon';	username = 'OH58_m134_pylon'; index = WSTYPE_PLACEHOLDER;}}	
})